//<clean=none></clean>
#ifndef dos_h
#define dos_h

struct dosconfig
{
double sigma;
double edge;
double m;
int dostype;
double Nt;
double Et;
double Nt2;
double Et2;
double Eshift;
double nstart;
double nstop;
double base1;
double base2;
int npoints;
int expan_len;
double expan_N[20];
double expan_E[20];
double mu;
double tau0;
double tau1;
double Tstart;
double Tstop;
double Ngaus;
int Tsteps;
int traps;
double dband;
double detrap;
int srh_bands;
double srh_start;

double srh_sigman;
double srh_sigmap;
double srh_vth;
double Nc;
double Nv;
double srh_cut;

double del_start;
double del_stop;
double Xi;
double Eg;
};

struct dos
{
int used;
double *x;
int xlen;
int tlen;
int srh_bands;
double *t;
double *srh_E;
double *srh_den;
double **c;
double **w;
double ***srh_r1;
double ***srh_r2;
double ***srh_r3;
double ***srh_r4;
double ***srh_c;
struct dosconfig config;
};

void dos_init();
void dos_free();
void dos_free_now(struct dos *mydos);

double get_n_pop_srh(double top,double T,int trap);
double get_p_pop_srh(double top,double T,int trap);
double get_dn_pop_srh(double top,double T,int trap);
double get_dp_pop_srh(double top,double T,int trap);

double get_n_w(double top,double T,double m,int type);
double get_p_w(double top,double T,double m,int type);
double get_top_from_n(double n,double T,double m,double Nc,int type);
double get_top_from_p(double p,double T,double m,double Nc,int type);
void load_dos(struct device *dev,char *namen, char *namep);
double get_n_den(double top,double T,double m,int type);
double get_dn_den(double top,double T,double m,int type);
double get_p_den(double top,double T,double m,int type);
double get_dp_den(double top,double T,double m,int type);
double get_dn_trap_den(double top,double T,double m,int type,int band);
double get_dp_trap_den(double top,double T,double m,int type);
int search(double *x,int N,double find);
double get_n_srh(double top,double T,int trap,int r);
double get_dn_srh(double top,double T,int trap,int r);
double get_p_srh(double top,double T,int trap,int r);
double get_dp_srh(double top,double T,int trap,int r);
double get_n_mu();
double get_p_mu();
#endif
